/*:VRX         Main
*/
Main:
    signal on halt
    parse arg SoundFile
    ok = VRRedirectStdIO("OFF")
    say SoundFile
    if (SoundFile = "") | (\VRFileExists(SoundFile)) then call beep 880, 200
    else do
        /* Load Multimedia-REXX-support laden und init */
        call RXFUNCADD 'mciRxInit','MCIAPI','mciRxInit'
        call mciRxInit
        AudioRC = mciRxSendString('open "'SoundFile'" alias eventsound shareable wait', 'RetStr', '0', '0')
        say 'open  AudioRC = 'AudioRC
        if AudioRC <> 0 then call LogError
        else do /* no error encountered */
            AudioRC = mciRxSendString('play eventsound wait', 'RetStr', '0', '0')
            say 'play  AudioRC = 'AudioRC
            if AudioRC <> 0 then  call LogError
            AudioRC = mciRxSendString('close eventsound wait', 'RetStr', '0', '0')
            say 'close AudioRC = 'AudioRC
            if AudioRC <> 0 then call LogError
        end
    end
    call Halt
exit

/*:VRX         Halt
*/
Halt:
    /* Make sure multimedia-REXX is properly terminated. */
    call mciRxExit
exit

/*:VRX         LogError
*/
LogError: 

return

