/*:VRX         Main
*/
/*  Main
*/
Main:
/*  Process the arguments.
    Get the parent window.
*/
    parse source . calledAs .
    parent = ""
    argCount = arg()
    argOff = 0
    if( calledAs \= "COMMAND" )then do
        if argCount >= 1 then do
            parent = arg(1)
            argCount = argCount - 1
            argOff = 1
        end
    end; else do
        call VROptions 'ImplicitNames'
        call VROptions 'NoEchoQuit'
    end
    InitArgs.0 = argCount
    if( argCount > 0 )then do i = 1 to argCount
        InitArgs.i = arg( i + argOff )
    end
    drop calledAs argCount argOff

/*  Load the windows
*/
    call VRInit
    parse source . . spec
    _VREPrimaryWindowPath = ,
        VRParseFileName( spec, "dpn" ) || ".VRW"
    _VREPrimaryWindow = ,
        VRLoad( parent, _VREPrimaryWindowPath )
    drop parent spec
    if( _VREPrimaryWindow == "" )then do
        call VRMessage "", "Cannot load window:" VRError(), ,
            "Error!"
        _VREReturnValue = 32000
        signal _VRELeaveMain
    end

/*  Process events
*/
    call Init
    signal on halt
    do while( \ VRGet( _VREPrimaryWindow, "Shutdown" ) )
        _VREEvent = VREvent()
        interpret _VREEvent
    end
_VREHalt:
    _VREReturnValue = Fini()
    call VRDestroy _VREPrimaryWindow
_VRELeaveMain:
    call VRFini
exit _VREReturnValue

VRLoadSecondary:
    __vrlsWait = abbrev( 'WAIT', translate(arg(2)), 1 )
    if __vrlsWait then do
        call VRFlush
    end
    __vrlsHWnd = VRLoad( VRWindow(), VRWindowPath(), arg(1) )
    if __vrlsHWnd = '' then signal __vrlsDone
    if __vrlsWait \= 1 then signal __vrlsDone
    call VRSet __vrlsHWnd, 'WindowMode', 'Modal' 
    __vrlsTmp = __vrlsWindows.0
    if( DataType(__vrlsTmp) \= 'NUM' ) then do
        __vrlsTmp = 1
    end
    else do
        __vrlsTmp = __vrlsTmp + 1
    end
    __vrlsWindows.__vrlsTmp = VRWindow( __vrlsHWnd )
    __vrlsWindows.0 = __vrlsTmp
    do while( VRIsValidObject( VRWindow() ) = 1 )
        __vrlsEvent = VREvent()
        interpret __vrlsEvent
    end
    __vrlsTmp = __vrlsWindows.0
    __vrlsWindows.0 = __vrlsTmp - 1
    call VRWindow __vrlsWindows.__vrlsTmp 
    __vrlsHWnd = ''
__vrlsDone:
return __vrlsHWnd

/*:VRX         _FirstSetup
*/
_FirstSetup: 
      /* determine status of Warp Center */
      startup_warp_center = 1
      If WPToolsFolderContent(startupfolder_default, 'list.', 'F') Then
         Do i = 1 To list.0
            If list.i = '<WP_WARPCENTER>' Then
               startup_warp_center = 0
         End
      If startup_warp_center Then
         startup_warp_center = (Pos('WARPCENTER', Translate(autostart_line)) > 0)
      Call SysIni our_ini, 'warp_center', 'sc_wait', startup_warp_center
      parms.0 = 1
      parms.1 = '<WP_WARPCENTER>'
      Perform('RxObjTitle', 'parms.');
      sc_title = parms.1
      Call SysIni our_ini, 'warp_center', 'sc_title', sc_title
      Call SysIni our_ini, 'warp_center', 'sc_tries', sc_tries_default
return

/*:VRX         _INIRead
*/
_INIRead: 
      our_ini             = 'RxAutoSt.INI'

      /* fully implemented settings */
      wps_wait            = VRGetIni( "workplace_shell", "wps_wait",         our_ini, 'Noclose')
      delay_wait          = VRGetIni( "workplace_shell", "delay_wait",       our_ini, 'Noclose')
      od_tries            = VRGetIni( "object_desktop",  "od_tries",         our_ini, 'Noclose')
      sleepsec            = VRGetIni( "objects",         "sleepsec",         our_ini, 'Noclose')
      retries             = VRGetIni( "objects",         "retries",          our_ini, 'Noclose')
      startupfolder       = VRGetIni( "folders",         "startupfolder",    our_ini, 'NoClose')
      lanstartupfolder    = VRGetIni( "folders",         "lanstartupfolder", our_ini, 'NoClose')
      enablelanstart      = VRGetIni( "folders",         "enablelanstart",   our_ini, 'NoClose')
      log_out             = VRGetIni( "debug",           "log_out",          our_ini, 'Noclose')
      verbose             = VRGetIni( "debug",           "verbose",          our_ini, 'NoClose')
      sound               = VRGetIni( "RexxAutoStart",   "Sound",            our_ini )

      if wps_wait            = '' then wps_wait            = VRGet("CB_wps_wait","set")
      if delay_wait          = '' then delay_wait          = VRGet("SPIN_delay_wait","Value")
      if od_tries            = '' then od_tries            = VRGet("SPIN_od_tries","Value")
      if sleepsec            = '' then sleepsec            = VRGet("SPIN_sleepsec","Value")
      if retries             = '' then retries             = VRGet("SPIN_retries","Value")
      if startupfolder       = '' then startupfolder       = VRGet("EF_Startupfolder","Value")
      if lanstartupfolder    = '' then lanstartupfolder    = VRGet("EF_LANStartupfolder","Value")
      if enablelanstart      = '' then enablelanstart      = VRGet("CB_EnableLANStartupfolder","Set")
      if log_out             = '' then logout              = VRGet("CB_log_out","set")
      if Verbose             = '' then verbose             = VRGet("CB_verbose","set")
      if sound               = '' then sound               = VRGet("CB_sound","set")

      ok = VRGet("CB_wps_wait","set",        wps_wait      )
      ok = VRSet("SPIN_delay_wait","Value",  delay_wait    )
      ok = VRSet("CB_delay","Set",           (delay_wait > 0))
      ok = VRSet("SPIN_od_tries","Value",    od_tries      )  
      ok = VRSet("SPIN_sleepsec","Value",    sleepsec      )  
      ok = VRSet("SPIN_retries","Value",     retries       )   
      ok = VRSet("EF_Startupfolder","Value", startupfolder )       
      ok = VRSet("EF_LANStartupfolder","Value", LANstartupfolder )       
      ok = VRSet("CB_EnableLANStartupfolder","Set", EnableLANstart )
      ok = VRGet("CB_log_out","set",         log_out       )
      ok = VRGet("CB_verbose","set",         verbose       )
      ok = VRGet("CB_sound","set",           sound         )

      ok = SysIni('USER', 'WPTS','ALL:',appstem.)
      objdesk = (appstem.0 > 0)
      
      ok = VRSet("CB_ODInstalled","set",objdesk)
      ok = VRSet("CB_od_cc", "Enabled",objdesk)
      ok = VRSet("CB_od_tlp","Enabled",objdesk)
      ok = VRSet("DT_od_tries1","Enabled",objdesk)
      ok = VRSet("DT_od_tries2","Enabled",objdesk)
      ok = VRSet("SPIN_od_tries","Enabled",objdesk)
      if objdesk then do
          od_cc           = VRGetIni( "object_desktop",  "od_cc",            our_ini, 'Noclose')
          od_tlp          = VRGetIni( "object_desktop",  "od_tlp",           our_ini )
          if od_cc        = '' then od_cc  = objdesk
          if od_tlp       = '' then od_tlp = objdesk
          ok = VRSet("CB_od_cc", "Set",od_cc)
          ok = VRSet("CB_od_tlp","Set",od_tlp)
      end

      /* partly implemented settings */      

      sc_title            = VRGetIni( "warp_center",     "sc_title",         our_ini, 'Noclose')
      sc_tries            = VRGetIni( "warp_center",     "sc_tries",         our_ini, 'Noclose')
      startup_warp_center = VRGetIni( "warp_center",     "sc_wait",          our_ini, 'Noclose')
      cc_title            = VRGetIni( "object_desktop",  "cc_title",         our_ini, 'Noclose')
      tlp_title           = VRGetIni( "object_desktop",  "tlp_title",        our_ini)

      if sc_title            = '' then sc_title            = 'WarpCenter'
      if sc_tries            = '' then sc_tries            = VRGet("SPIN_sc_tries","Value")
return

/* 
      /* object desktop */
      Call SysIni our_ini, 'object_desktop', 'od_cc', 0
      parms.0 = 1
      parms.1 = '<OBJD_CONTROLCENTER>'
      Perform('RxObjTitle', 'parms.');
      cc_title = parms.1
      If cc_title = '' Then
         cc_title = 'NA'
      Call SysIni our_ini, 'object_desktop', 'cc_title', cc_title
      Call SysIni our_ini, 'object_desktop', 'od_tlp', 0
      parms.0 = 1
      parms.1 = '<OBJD_TABLAUNCHPAD>'
      Perform('RxObjTitle', 'parms.');
      tlp_title = parms.1
      If tlp_title = '' Then
         tlp_title = 'NA'
      Call SysIni our_ini, 'object_desktop', 'tlp_title', tlp_title
      Call SysIni our_ini, 'object_desktop', 'od_tries', od_tries_default

      Call SysIni our_ini, 'workplace_shell', 'delay_wait', delay_wait_default

      Call SysIni our_ini, 'objects', 'retries', retries_default

      Call SysIni our_ini, 'folders', 'lanstartupfolder', '<WP_START_LAN>'

      Call SysIni our_ini, 'objects', 'sleepsec', sleepsec_default

      Call SysIni our_ini, 'debug', 'log_out', 0

      Call SysIni our_ini, 'debug', 'verbose', 0

      If old_parms <> '' Then
         Do
            /* update from old parameters file */
            reply = SendMsgBox('Msg019');

            /* wait for WarpCenter */
            Parse Value('.' old_parms) With . '/SC:' sc_tries '/'.
            sc_tries = Strip(sc_tries)
            If sc_tries <> '' & Datatype(sc_tries, 'W') Then
               Call SysIni our_ini, 'warp_center', 'sc_tries', sc_tries
            /* wait for Object Desktop */
            /* determine which facilities to wait for */
            If objdesk Then
               Do
                  /* wait for Control Center */
                  od_cc = (Pos('/ODC', old_parms) <> 0)
                  If od_cc Then
                     Call SysIni our_ini, 'object_desktop', 'od_cc', od_cc
                  /* wait for Tab LaunchPad */
                  od_tlp = (Pos('/ODT', old_parms) <> 0)
                  If od_tlp Then
                     Call SysIni our_ini, 'object_desktop', 'od_tlp', od_tlp
                  /* determine number of checks for Object Desktop tasks */
                  Parse Value('.' old_parms) With . '/OD:' od_tries '/'.
                  od_tries = Strip(od_tries)
                  If od_tries <> '' & Datatype(od_tries, 'W') Then
                     Call SysIni our_ini, 'object_desktop', 'od_tries', od_tries
               End

            Parse Value('.' old_parms) With . '/D:' delay_wait '/' .
            delay_wait = Strip(delay_wait)
            If delay_wait <> '' & Datatype(delay_wait, 'W') Then
               Call SysIni our_ini, 'workplace_shell', 'delay_wait', delay_wait

            Parse Value('.' old_parms) With . '/R:' retries '/' .
            retries = Strip(retries)
            If retries <> '' & Datatype(retries, 'W') Then
               Call SysIni our_ini, 'objects', 'retries', retries

            /* object id of startup folder */
            f_pos = Pos('/F:', old_parms)
            If f_pos <> 0 Then
               Do
                  Parse Value('.' old_parms) With . + (f_pos) + 4 startupfolder '/' .
                  startupfolder = Strip(Strip(Strip(startupfolder), , '"'), , "'")
                  Call SysIni our_ini, 'folders', 'startupfolder', startupfolder
               End

            Parse Value('.' old_parms) With . '/P:' sleepsec '/' .
            sleepsec = Strip(sleepsec)
            If sleepsec <> '' & Datatype(sleepsec, 'W') Then
               Call SysIni our_ini, 'objects', 'sleepsec', sleepsec

            log_out = (Pos('/L', old_parms) <> 0)
            If log_out Then
               Call SysIni our_ini, 'debug', 'log_out', log_out

            verbose = (Pos('/V', old_parms) <> 0)
            If verbose Then
               Call SysIni our_ini, 'debug', 'verbose', verbose
         End
   End
*/
/*:VRX         _INIWrite
*/
_INIWrite: 
    ok = VRSetIni( "workplace_shell", "wps_wait",         wps_wait,         our_ini )
    ok = VRSetIni( "workplace_shell", "delay_wait",       delay_wait,       our_ini )
    ok = VRSetIni( "object_desktop",  "od_tries",         od_tries,         our_ini )
    ok = VRSetIni( "objects",         "sleepsec",         sleepsec,         our_ini )
    ok = VRSetIni( "objects",         "retries",          retries,          our_ini )
    ok = VRSetIni( "folders",         "startupfolder",    startupfolder,    our_ini )
    ok = VRSetIni( "folders",         "lanstartupfolder", lanstartupfolder, our_ini )
    ok = VRSetIni( "folders",         "enablelanstart",   enablelanstart,   our_ini )
    ok = VRSetIni( "debug",           "log_out",          log_out,          our_ini )
    ok = VRSetIni( "debug",           "verbose",          verbose,          our_ini )
    ok = VRSetIni( "RexxAutoStart",   "Sound",            sound,            our_ini )

    ok = VRSetIni( "object_desktop",  "od_cc",            od_cc,            our_ini )
    ok = VRSetIni( "object_desktop",  "od_tlp",           od_tlp,           our_ini )

return

/*:VRX         _StartUpCMDActivate
*/
_StartUpCMDActivate: 
    if Gotcha <> 0 then StartupLine.Gotcha = RxAutoStLine
    else do
        if \IsRexx then ok = SysStemInsert(StartUpLine., 1, RxAutoStLine)
        else do
            ok = SysStemInsert(StartUpLine., 1, '/* REXX --- added by RxAutoUt --- */')    
            ok = SysStemInsert(StartUpLine., 2, RxAutoStLine)
        end             
    end            
return

/*:VRX         _StartUpCMDCheckExistence
*/
_StartUpCMDCheckExistence: 
    StartUpCMD =  SysBootDrive() ||'\StartUp.CMD'
    ok = SysFileTree(StartUpCMD, StartupCMD.,'FO')
    if StartUpCMD.0 = 1 then StartUpExists = 1
                        else StartUpExists = 0
    ok = VRSet("MenuEditCreateStartUpCMD","Enabled", \StartUpExists)
    ok = VRSet("MenuEditModifyStartUpCMD","Enabled", StartUpExists)
    ok = VRSet("MenuEditDeleteStartUpCMD","Enabled", StartUpExists)
return

/*:VRX         _StartUpCMDRead
*/
_StartUpCMDRead:
    RxAutoStLine = '@start /min 'directory()'\rxautost.exe'
    I = 0
    Gotcha = 0
    IsREXX = 0
    do until lines(StartUPCMD) = 0
        I = I + 1
        StartUpLine.I = linein(StartUPCMD)
        if I = 1 then if left(StartUpLine.I,2) = '/*' then IsREXX = 1
        if pos('RXAUTOST.EXE',translate(StartUpLine.I)) > 0 then do
            Gotcha = I
        end
    end
    call Lineout(StartUpCMD)
    StartupLine.0 = I
    if IsREXX then RxAutoStLine = "'"RxAutoStLine"'"
return

/*:VRX         _StartUpCMDWrite
*/
_StartUpCMDWrite: 
    ok = SysFileDelete(SysBootDrive()'\Startup.RXB')
    ok = VRCopyFile(StartupCMD, SysBootDrive()'\Startup.RXB')
    ok = SysFileDelete(StartupCMD)
    do I = 1 to StartupLine.0
        ok = lineout(StartupCmd, StartupLine.I)
    end
    call lineout(StartUpCMD)
return

/*:VRX         AboutBox_Close
*/
AboutBox_Close: 
    call AboutBox_Fini
return

/*:VRX         AboutBox_Create
*/
AboutBox_Create: 
    call AboutBox_Init
return

/*:VRX         AboutBox_Fini
*/
AboutBox_Fini: 
    window = VRInfo( "Window" )
    call VRDestroy window
    drop window
return
/*:VRX         AboutBox_Init
*/
AboutBox_Init: 
    window = VRInfo( "Object" )
    if( \VRIsChildOf( window, "Notebook" ) ) then do
        call VRMethod window, "CenterWindow"
        call VRSet window, "Visible", 1
        call VRMethod window, "Activate"
    end
    drop window
return

/*:VRX         CB_DELAY_Click
*/
CB_DELAY_Click: 
    if VRget("CB_DELAY","set") then do
        ok = VRSet("SPIN_delay_wait","Enabled", 1) 
        delay_wait = VRGet("SPIN_delay_wait","Value")
    end
    else do
        ok = VRSet("SPIN_delay_wait","Value", 0)
        ok = VRSet("SPIN_delay_wait","Enabled", 0) 
    end
return

/*:VRX         CB_EnableLanStartUpFolder_Click
*/
CB_EnableLanStartUpFolder_Click: 
    enablelanstart = VRGet("CB_EnableLanStartUpFolder","set")
return

/*:VRX         CB_od_cc_Click
*/
CB_od_cc_Click: 
    od_cc = VRGet("CB_od_cc","set")
return

/*:VRX         CB_od_tlp_Click
*/
CB_od_tlp_Click: 
    od_tlp = VRGet("CB_od_tlp","set")
return

/*:VRX         CB_ODInstalled_Click
*/
CB_ODInstalled_Click: 
    ok = SysIni('USER', 'WPTS','ALL:',appstem.)
    objdesk = (appstem.0 > 0)
    ok = VRSet("CB_ODInstalled","set",objdesk)
return

/*:VRX         CB_Sound_Click
*/
CB_Sound_Click: 
    Sound = VRGet("CB_Sound","set")
return

/*:VRX         EF_LANStartUpFolder_Change
*/
EF_LANStartUpFolder_Change: 
    lanstartupfolder = VRGet("EF_LANstartUpFolder","Value")
    if left(LANstartupfolder,1) \= '<' | right(LANstartupfolder,1) \= '>' then do
        ok = VRSet("EF_LANstartUpFolder","BackColor","Red")
    end
    else ok = VRSet("EF_LANstartUpFolder","BackColor","<default>")
return

/*:VRX         EF_StartUpFolder_Change
*/
EF_StartUpFolder_Change: 
    startupfolder = VRGet("EF_StartUpFolder","Value")
    if left(startupfolder,1) \= '<' | right(startupfolder,1) \= '>' then do
        ok = VRSet("EF_StartUpFolder","BackColor","Red")
    end
    else ok = VRSet("EF_StartUpFolder","BackColor","<default>")
return

/*:VRX         Fini
*/
Fini:
    window = VRWindow()
    call VRSet window, "Visible", 0
    drop window
return 0

/*:VRX         GetBootDrive
*/
GetBootDrive: 
    if (OS2Version >= 2.40) /* I don' t want to use SysBootDrive on Warp 3 */
        then return SysBootDrive()
        else return left(value('RUNWORKPLACE',,'OS2ENVIRONMENT'),2)
return

/*:VRX         Halt
*/
Halt:
    signal _VREHalt
return

/*:VRX         Init
*/
Init:
    BootDrive = GetBootDrive()
    window = VRWindow()
    call VRMethod window, "CenterWindow"
    call VRSet window, "Visible", 1
    call VRMethod window, "Activate"
    drop window
return

/*:VRX         MenuEditCreateStartUpCMD_Click
*/
MenuEditCreateStartUpCMD_Click:
    call lineout StartupCMD, '@rem --- created by RxAutoUt ---'
    call lineout StartupCMD, '@start /min 'directory()'\rxautost.exe'
    call lineout StartupCMD, '@exit'
    call lineout StartupCMD
    call _StartUpCMDCheckExistence
return

/*:VRX         MenuEditDeleteStartUpCMD_Click
*/
MenuEditDeleteStartUpCMD_Click: 
    ok = SysFileDelete(STARTUPCMD)
    call _StartupCMDCheckExistence
return

/*:VRX         MenuEditModifyStartUpCMD_Click
*/
MenuEditModifyStartUpCMD_Click: 
    call _StartUpCMDRead
    call _StartUpCMDActivate
    call _StartUpCMDWrite
    ok = SysSetObjectData(SysBootDrive()'\Startup.CMD','OPEN=TEXT;')
    call _StartUpCMDCheckExistence
return

/*:VRX         MenuFileExit_Click
*/
MenuFileExit_Click: 
    call Quit
return

/*:VRX         MenuHelpAbout_Click
*/
MenuHelpAbout_Click: 
    window = VRLoadSecondary( "AboutBox", "W" )
return

/*:VRX         MenuHelpViewManual_Click
*/
MenuHelpViewManual_Click: 
    'view rxautost.inf'
return

/*:VRX         Page1_Close
*/
Page1_Close: 
    call General_Fini
return

/*:VRX         Page1_Create
*/
Page1_Create: 
    call Page1_Init
    call Page2_Init
    call Page3_Init
    call Page4_Init
    call _INIRead
return

/*:VRX         Page1_Fini
*/
Page1_Fini: 
    window = VRInfo( "Window" )
    call VRDestroy window
    drop window
return
/*:VRX         Page1_Init
*/
Page1_Init: 
    window = VRInfo( "Object" )
    if( \VRIsChildOf( window, "Notebook" ) ) then do
        call VRMethod window, "CenterWindow"
        call VRSet window, "Visible", 1
        call VRMethod window, "Activate"
    end
    drop window
return

/*:VRX         Page2_Close
*/
Page2_Close: 
    call PageExecution_Fini
return

/*:VRX         Page2_Create
*/
Page2_Create: 
    call Page2_Init
return

/*:VRX         Page2_Fini
*/
Page2_Fini: 
    window = VRInfo( "Window" )
    call VRDestroy window
    drop window
return
/*:VRX         Page2_Init
*/
Page2_Init: 
    window = VRInfo( "Object" )
    if( \VRIsChildOf( window, "Notebook" ) ) then do
        call VRMethod window, "CenterWindow"
        call VRSet window, "Visible", 1
        call VRMethod window, "Activate"
    end
    drop window
return

/*:VRX         Page3_Close
*/
Page3_Close: 
    call Page3_Fini
return

/*:VRX         Page3_Create
*/
Page3_Create: 
    call Page3_Init
return

/*:VRX         Page3_Fini
*/
Page3_Fini: 
    window = VRInfo( "Window" )
    call VRDestroy window
    drop window
return
/*:VRX         Page3_Init
*/
Page3_Init: 
    window = VRInfo( "Object" )
    if( \VRIsChildOf( window, "Notebook" ) ) then do
        call VRMethod window, "CenterWindow"
        call VRSet window, "Visible", 1
        call VRMethod window, "Activate"
    end
    drop window
return

/*:VRX         Page4_Close
*/
Page4_Close: 
    call PageScript_Fini
return

/*:VRX         Page4_Create
*/
Page4_Create: 
    call Page4_Init
return

/*:VRX         Page4_Fini
*/
Page4_Fini: 
    window = VRInfo( "Window" )
    call VRDestroy window
    drop window
return
/*:VRX         Page4_Init
*/
Page4_Init: 
    window = VRInfo( "Object" )
    if( \VRIsChildOf( window, "Notebook" ) ) then do
        call VRMethod window, "CenterWindow"
        call VRSet window, "Visible", 1
        call VRMethod window, "Activate"
    end
    drop window
return

/*:VRX         ParkingLot
*/
ParkingLot: 
    say 'RxAutoSt.EXE in PATH?'
    say 'Envar RxAutoSt set?'
    say 'RESTARTOBJECTS set?'
    say 'AUTOSTART set?'
    say 'RxAutoSt.EXE in STARTUP.CMD?'
/* SET AUTOSTART=PROGRAMS,TASKLIST,FOLDERS
   SET RESTARTOBJECTS=STARTUPFOLDERSONLY
   SET RXAUTOST=/WPS /D:20 /X /E */
return

/*:VRX         PB_AboutBox_OK_Click
*/
PB_AboutBox_OK_Click: 
    call AboutBox_Close
return

/*:VRX         PB_Cancel_Click
*/
PB_Cancel_Click: 
    call Quit
return

/*:VRX         PB_InstallSound_Click
*/
PB_InstallSound_Click: 
    /* This routine is loosely based on Mr. XWPS, Ulrich Mller's sound001.cmd */

    /* enable new RexxAutoStart system sound */
    MMINI = SysBootDrive()||"\MMOS2\MMPM.INI"

    /* these are the titles of the sounds to be created */
    RexxAutoStart_Done  = "RexxAutoStart: Done" 
    RexxAutoStart_Abort = "RexxAutoStart: Abort"
    RexxAutoStart_Open  = "RexxAutoStart: Open object" 

    /* Create empty sound entries */
    rc = SysINI(MMINI, "MMPM2_AlarmSounds", "681", "#"|| RexxAutoStart_Done ||"#100")    
    rc = SysINI(MMINI, "MMPM2_AlarmSounds", "682", "#"|| RexxAutoStart_Abort||"#100")   
    rc = SysINI(MMINI, "MMPM2_AlarmSounds", "683", "#"|| RexxAutoStart_Open ||"#100")

    /* open WP_SOUND */
    ok = SysOpenObject("<WP_SOUND>","DEFAULT",1)
return

/*:VRX         PB_Set_Click
*/
PB_Set_Click: 
    call _INIWrite
Buttons.1 = "OK"
Buttons.0 = 1
id = VRMessage( VRWindow(), "Saving of options to RxAutoSt.INI complete", "Saving RexxAutoStart options", "Information", "Buttons.", 1, 1 )

return
/*:VRX         PB_SoundConfig_Click
*/
PB_SoundConfig_Click: 
    /* open WP_SOUND */
    ok = SysOpenObject("<WP_SOUND>","DEFAULT",1)
return

/*:VRX         PB_St_Cancel_Click
*/
PB_St_Cancel_Click: 
    call StartupCMDWindow_Close
return

/*:VRX         PB_StartupCMD_Click
*/
PB_StartupCMD_Click: 


    if \StartUpExists then do /* create a new one */
        call lineout StartupCMD, '@rem --- created by RxAutoUt ---'
        call lineout StartupCMD, '@start /min 'directory()'\rxautost.exe'
        call lineout StartupCMD, '@exit'
        call lineout StartupCMD
    end
    else do /* there is one */
        window = VRLoadSecondary( "StartupCMDWindow", "W" )
    end
return
/*:VRX         PB_Undo_Click
*/
PB_Undo_Click: 
    call _INIRead
return

/*:VRX         PB_UnInstallSound_Click
*/
PB_UnInstallSound_Click: 
    MMINI = SysBootDrive()||"\MMOS2\MMPM.INI"
    do I = 681 to 683
        rc = SysINI(MMINI, "MMPM2_AlarmSounds", I, "DELETE:")
    end

    /* open WP_SOUND */
    ok = SysOpenObject("<WP_SOUND>","DEFAULT",1)
return

/*:VRX         Quit
*/
Quit:
    Buttons.1 = "Yes"
    Buttons.2 = "No"
    Buttons.0 = 2
    id = VRMessage( VRWindow(), "Really want leave RexxAutoStart setup utility now?", "Setup RexxAutoStart", "Query", "Buttons.", 1, 2 )
    if id = 2 then return
    window = VRWindow()
    call VRSet window, "Shutdown", 1
    drop window
return

/*:VRX         RxAutoUtMain_Close
*/
RxAutoUtMain_Close:
    call Quit
return

/*:VRX         RxAutoUtMain_Create
*/
RxAutoUtMain_Create: 
    call _StartUpCMDCheckExistence
return

/*:VRX         SPIN_delay_wait_Change
*/
SPIN_delay_wait_Change: 
    delay_wait = VRGet("SPIN_delay_wait","Value")
return

/*:VRX         SPIN_od_tries_Change
*/
SPIN_od_tries_Change: 
    od_tries = VRGet("SPIN_od_tries","Value")
return

/*:VRX         SPIN_retries_Change
*/
SPIN_retries_Change: 
    retries = VRget("SPIN_retries","Value")
return

/*:VRX         SPIN_sleepsec_Change
*/
SPIN_sleepsec_Change: 
    sleepsec = VRGet("SPIN_sleepsec","Value")
return

/*:VRX         StartUpCMDRead
*/
StartUpCMDRead: 
    STUP = BootDrive'\STARTUP.CMD'
    I = 0
    do while lines(STUP) > 0
        I = I + 1
        STUPL.I = linein(STUP)
    end
    STUPL.0 = I
return

/*:VRX         StartupCMDWindow_Activate
*/
StartupCMDWindow_Activate: 
return

/*:VRX         StartupCMDWindow_Close
*/
StartupCMDWindow_Close: 
    call StartupCMDWindow_Fini
return

/*:VRX         StartupCMDWindow_Create
*/
StartupCMDWindow_Create: 
    call StartupCMDWindow_Init
    call _ReadStartUpCMD
    ok = VRMethod('LB_StartupCMD', "Reset")      
    ok = VRMethod('LB_StartupCMD', "AddStringList", "StartUpLine." ) 
return

/*:VRX         StartupCMDWindow_Fini
*/
StartupCMDWindow_Fini: 
    window = VRInfo( "Window" )
    call VRDestroy window
    drop window
return
/*:VRX         StartupCMDWindow_Init
*/
StartupCMDWindow_Init: 
    window = VRInfo( "Object" )
    if( \VRIsChildOf( window, "Notebook" ) ) then do
        call VRMethod window, "CenterWindow"
        call VRSet window, "Visible", 1
        call VRMethod window, "Activate"
    end
    drop window
return

/*:VRX         StartUpCMDWrite
*/
StartUpCMDWrite: 

return

