/*:VRX         Main
*/
/*  Main
*/
Main:
/*  Process the arguments.
    Get the parent window.
*/
    parse source . calledAs .
    parent = ""
    argCount = arg()
    argOff = 0
    if( calledAs \= "COMMAND" )then do
        if argCount >= 1 then do
            parent = arg(1)
            argCount = argCount - 1
            argOff = 1
        end
    end; else do
        call VROptions 'ImplicitNames'
        call VROptions 'NoEchoQuit'
    end
    InitArgs.0 = argCount
    if( argCount > 0 )then do i = 1 to argCount
        InitArgs.i = arg( i + argOff )
    end
    drop calledAs argCount argOff

/*  Load the windows
*/
    call VRInit
    parse source . . spec
    _VREPrimaryWindowPath = ,
        VRParseFileName( spec, "dpn" ) || ".VRW"
    _VREPrimaryWindow = ,
        VRLoad( parent, _VREPrimaryWindowPath )
    drop parent spec
    if( _VREPrimaryWindow == "" )then do
        call VRMessage "", "Cannot load window:" VRError(), ,
            "Error!"
        _VREReturnValue = 32000
        signal _VRELeaveMain
    end

/*  Process events
*/
    call Init
    signal on halt
    do while( \ VRGet( _VREPrimaryWindow, "Shutdown" ) )
        _VREEvent = VREvent()
        interpret _VREEvent
    end
_VREHalt:
    _VREReturnValue = Fini()
    call VRDestroy _VREPrimaryWindow
_VRELeaveMain:
    call VRFini
exit _VREReturnValue

VRLoadSecondary:
    __vrlsWait = abbrev( 'WAIT', translate(arg(2)), 1 )
    if __vrlsWait then do
        call VRFlush
    end
    __vrlsHWnd = VRLoad( VRWindow(), VRWindowPath(), arg(1) )
    if __vrlsHWnd = '' then signal __vrlsDone
    if __vrlsWait \= 1 then signal __vrlsDone
    call VRSet __vrlsHWnd, 'WindowMode', 'Modal' 
    __vrlsTmp = __vrlsWindows.0
    if( DataType(__vrlsTmp) \= 'NUM' ) then do
        __vrlsTmp = 1
    end
    else do
        __vrlsTmp = __vrlsTmp + 1
    end
    __vrlsWindows.__vrlsTmp = VRWindow( __vrlsHWnd )
    __vrlsWindows.0 = __vrlsTmp
    do while( VRIsValidObject( VRWindow() ) = 1 )
        __vrlsEvent = VREvent()
        interpret __vrlsEvent
    end
    __vrlsTmp = __vrlsWindows.0
    __vrlsWindows.0 = __vrlsTmp - 1
    call VRWindow __vrlsWindows.__vrlsTmp 
    __vrlsHWnd = ''
__vrlsDone:
return __vrlsHWnd

/*:VRX         _autoexec
*/
_autoexec: 
    /* launch startup folder objects */
    say '_Autoexec entered'
    save_trace = Trace(sub_trace)

    /* query our startup folder */
    If WPToolsFolderContent(startupfolder, 'list.', 'F') Then Do
        Call _sayout "Adding objects from startup folder" startupfolder".", 1
        Call _sayout sleepsec "seconds of delay between objects will be inserted.", 2

        /* open objects in startup folder */
        open_parm = 'OPEN=DEFAULT;CCVIEW=NO;'
        list_start = 1
        list_end = list.0
        list_incr = 1
        If wseb Then Do
            list_start = list.0
            list_end = 1
            list_incr = -1
        End
        Do i = list_start To list_end By list_incr
            If WPToolsQueryObject(list.i, 'szclass', 'sztitle') Then Do
                title = _objtitle(sztitle)
                /* Call _sayout "Adding object '"title"' of class "szclass'.', 2 */
                /* try to open object, tell us what happened */
                success = 0
                Do x = 1 To retries Until success
                    call _SleepAnimated
                    success = WPToolsSetObjectData(list.i, open_parm)
                    say 'WPToolsSetObjectData('list.i',' open_parm')'
                    call CheckForEvent
                End
                If success Then open_msg = '['title'] has opened after' x 'attempt(s) of' retries || '.'
                           Else open_msg = '['title'] failed to open after' retries 'attempts.'
                ok = VRSet("SL_Progress","Percentile",trunc(I *100 /list_end))
                call _PlaySoundEvent("683")
                Call _sayout open_msg, 3
            End
            Else Call _sayout 'Could not locate for object' title || '.', 2
        End
        Call _sayout 'Objects in' startupfolder 'have been opened.', 1
    End
    Else Do
        Call _sayout 'Failure:' startupfolder 'could not be queried. Continuing...', 1
    End
    Trace (save_trace)
    say '_Autoexec done'
return 0
/*:VRX         _cleanup
*/
_cleanup: 
    parse arg One
    say '_CleanUp 'One
    call _INIWrite
    /* call beep 880, 20 */
return 0

/*:VRX         _delayswitch
*/
_delayswitch: 
    /* /D (delay) switch logic */
    say '_delayswitch'
    call CheckForEvent
    Call _sayout 'Delay further execution by' delay_wait 'seconds.', 1
    do x = 1 to delay_wait
        Call SysSleep 1
        call CheckForEvent
    end
    Call _sayout delay_wait' seconds have passed. Continuing...', 2
return 0
/*:VRX         _GetEventSound
*/
_GetEventSound: 
    parse arg EventCode
    SoundFileEntry = VRGetIni( "MMPM2_AlarmSounds", EventCode, SysBootDrive()"\MMOS2\MMPM.INI" )
    say 'SoundFileEntry  = !!!'SoundFileEntry'!!!'
    if SoundFileEntry \= '' then do /* Sound defined */
        SoundFile = left(SoundFileEntry,pos('#',SoundFileEntry)-1)
    end
    else SoundFile = ''
    say "SoundFile = >>"SoundFile"<<"
return SoundFile
/*:VRX         _helpscreen
*/
_helpscreen: 
 
Lines.1 = 'RexxAutoStart Version 'ver' ('verdate') (c) 1998-2000 by Herwig Bauernfeind and Chuck McKinnis'
Lines.2 = 'This is FREE software under the terms of the GNU General Public License.'
Lines.3 = ' '
Lines.4 = 'Using 'rxname' Version 'rxver' ('rxdate')'
Lines.5 = 'Using WPTools Version 'wptver' (c) copyright by Henk Kelder'
Lines.6 = 'Using VX-REXX Version 'VRVersion('VROBJ.DLL')
Lines.7 = ' '
Lines.8 = '/WPS'copies(' ',20)'Delay execution until desktop is populated.'
Lines.9 = '/D:n'copies(' ',24)'Delay execution of this program by n seconds.'
Lines.10= '/OD[:n]'copies(' ',18)'Delay execution until Object Desktop is opened or a maximum of n tries'
Lines.11= copies(' ',32)'(default = 30) delayed by /P:n seconds (default = 2). (by Chuck McKinnis)'
Lines.12= '/P:n'copies(' ',24)'Pause between objects should be n seconds. Default = 2.'
Lines.13= '/R:n'copies(' ',24)'Number of attempts to open an object. Default = 2.'
Lines.14= '/F:"<FolderID>"  Folder which should be treated as startup folder.'
Lines.15= '/V'copies(' ',28)'Verbose. Give us some hints what we are doing right now.'
Lines.16= '/L'copies(' ',28)'Log results to' log_file || '.'
Lines.17= ' '
Lines.0 = 17
Buttons.1 = "OK"
Buttons.0 = 1
id = VRMessageStem( VRWindow(), "Lines.", "Usage help", "Information", "Buttons.", 1, 1 )



return 0

/*:VRX         _INIRead
*/
_INIRead: 
    /* position */
    ok = VRSet("RexxAutoStartMain","Left",VRGetIni( "RexxAutoStart", "Left", our_ini , 'NoClose'))
    ok = VRSet("RexxAutoStartMain","Top", VRGetIni( "RexxAutoStart", "Top",  our_ini , 'NoClose'))

    /* Sound */
    Sound = VRGetIni( "RexxAutoStart", "Sound",  our_ini,'NoClose' )
    if Sound = '' then Sound = VRget("CB_Sound","set")
        else ok = VRset("CB_Sound","set",Sound)

    /* color */
    Backcolor = VRGetIni( "RexxAutoStart", "BackColor",  our_ini )
    if BackColor = '' then BackColor = VRGet("RexxAutoStartMain","BackColor")
        else ok = VRset("RexxAutoStartMain","BackColor",BackColor)

    /* et voila */
    ok = VRSet("RexxAutoStartMain", "Visible", 1)

    /* some parameter defaults */
    wps_wait                  = VRGetIni( "workplace_shell", "wps_wait",         our_ini, 'Noclose')
    delay_wait_default        = VRGetIni( "workplace_shell", "delay_wait",       our_ini, 'Noclose')
    od_tries_default          = VRGetIni( "object_desktop",  "od_tries",         our_ini, 'Noclose')
    sleepsec_default          = VRGetIni( "objects",         "sleepsec",         our_ini, 'Noclose')
    retries_default           = VRGetIni( "objects",         "retries",          our_ini, 'Noclose')
    startupfolder_default     = VRGetIni( "folders",         "startupfolder",    our_ini, 'Noclose')
    log_out                   = VRGetIni( "debug",           "log_out",          our_ini, 'Noclose')
    verbose                   = VRGetIni( "debug",           "verbose",          our_ini )

    if wps_wait               = '' then wps_wait = 1    
    if delay_wait_default     = '' then delay_wait_default = 0
    if od_tries_default       = '' then od_tries_default = 30
    if sleepsec_default       = '' then sleepsec_default = 2
    if retries_default        = '' then retries_default = 2
    if startupfolder_default  = '' then startupfolder_default = '<WP_START>'
    if log_out                = '' then log_out = 0
    if verbose                = '' then verbose = 1
return

/*:VRX         _Initialize
*/
_Initialize: /* Initialize libraries */
    /* determine REXX level we are running on */
    Parse Version rxname rxver rxdate

    /* initialize */ 
    ver = '1.8.0'
    verdate = '19.02.2001'
    ok = VRSet("RexxAutoStartMain","Caption","RexxAutoStart "ver)

    /* check operating system */
    if RxFuncQuery(SysVersion) = 0 then do
        Parse Value(SysVersion()) With op_sys op_lvl
    end
    else do /* older OS/2, probably Warp 3 */
        op_lvl = SysOS2Ver()
        op_sys = 'OS/2'
    end
    sys_os2 = SysSearchPath('path', 'syslevel.os2')
    sys_info = Charin(sys_os2, 1, 150)
    Parse Var sys_info . 61 os_name 141 os_comp 150
    os_name = Strip(os_name, 't', '00'x)

    warp4 = (op_lvl >= 2.40)
    ecs = (os_comp = '5639A6101')
    wseb_uni = (os_comp = '5639A6150')
    wseb_smp = (os_comp = '5639A5550')
    wseb = wseb_uni | wseb_smp
    
    /* locate the executable */
    exe_file = Stream('rxautost.exe', 'c', 'query exists')
    If exe_file = '' Then Do
        exe_file = SysSearchPath('PATH', 'rxautost.exe')
        If exe_file = '' Then Do
            Msg.Title = 'Error'
            Msg.Type  = 'E'
            Msg.Text  = 'Unable to locate rxautost.exe'
            call _MsgOK
            call PB_Exit_Click
        End
    end

    /* locate the base directory for RxAutoSt, logfile and INIfile */
    base_dir = Filespec('d', exe_file) || Filespec('p', exe_file)
    our_ini  = base_dir || 'RxAutoSt.INI'
    log_file = base_dir || 'RxAutoSt.LOG'

    /* Parameter treatment:
       1. Read INI file
       2. Read RXAUTOST enviroment variable (overrides 1, should not be used)
       3. Read commandline parameters (override 1 and 2, optional)
     */

    /* Read the INI file */
    call _INIRead

    /* let commandline parameters override config.sys parameters */
    orgparms = Strip(orgparms Value('rxautost', , 'os2environment'))

    /* we need this for /F switch to preserve case of ObjectIDs */
    parms = Translate(orgparms)
    /* get some initial parameters */
    if (Pos('/V',parms) <> 0) then verbose = 1             /* verbose output */
    if (Pos('/L',parms) <> 0) then log_out = 1                    /* logging */
    testing = (Pos('/T',parms) <> 0)          /* undocumented test parameter */
    If testing Then
    Do
        verbose = 1
        log_out = 1
    End
    if (Pos('/WPS',parms) <> 0) then wps_wait = 1 /* wait for WPS population */

    if (Pos('/D',parms) <> 0) then do
        Parse Value('.' parms) With . '/D:' delay_wait '/'.      /* delay switch */
        delay_wait = Strip(delay_wait)
        If delay_wait = '' | \Datatype(delay_wait, 'W') Then delay_wait = delay_wait_default
    end
    else delay_wait = delay_wait_default

    /* Object Desktop information */
    odtest = SysIni('USER','WPTS','TSMasterSetup:StartupFlags')
    objdesk = (odtest <> 'ERROR:')            /* object desktop installed */
    If objdesk Then             /* determine which facilities to wait for */
    Do
        od_wait = (Pos('/OD',parms) <> 0)    /* wait for Object Desktop */
        odtest = Left(odtest, Length(odtest) - 1)
        od_cc = (odtest >= C2x('28'x))
        od_tlp = (odtest >= C2x('28'x))
        od_tlp = (odtest >= C2x('24'x))
        od_cc = (odtest >= C2x('20'x))
        /* determine number of checks for Object Desktop tasks */
        Parse Value('.' parms) With . '/OD:' od_tries '/'.
        od_tries = Strip(od_tries)
        If od_tries = '' | \Datatype(od_tries, 'W') Then
           od_tries = od_tries_default
    End
    Else
        od_wait = 0

    /* /P switch (pause between object) */
    Parse Value('.' parms) With . '/P:' sleepsec '/' .
    sleepsec = Strip(sleepsec)
    If sleepsec = '' Then
        sleepsec = sleepsec_default

    /* open log file */
    /* Call Stream log_file, 'c', 'open write' */

    /* /F switch (make any folder your startup folder) */
    f_pos = Pos('/F:', parms)
    If f_pos <> 0 Then
    Do
        Parse Value('.' orgparms) With . + (f_pos) + 4 startupfolder '/' .
        startupfolder = Strip(Strip(Strip(startupfolder), , '"'), , "'")
    End
    Else
        startupfolder = startupfolder_default

    /* /R switch (open object retries) */
    Parse Value('.' parms) With . '/R:' retries '/' .
    retries = Strip(retries)
    If retries = '' Then
        retries = retries_default

    /* Do we need help? */
    If Pos('/?', cmdparms) <> 0 Then /* | cmdparms = '' */
        do_help = 1
    Else
        do_help = 0

    /* set miscellaneous options */

    /* are we going to execute RxAutoSt? */
    autoexec = 1 /* (Pos('/X', parms) <> 0) */
return 1

/*:VRX         _INIWrite
*/
_INIWrite: 
    ok = VRSetIni( "RexxAutoStart", "Left", VRGet("RexxAutoStartMain","Left"), our_ini, 'NoClose' )
    ok = VRSetIni( "RexxAutoStart", "Top",  VRGet("RexxAutoStartMain","Top"),  our_ini, 'NoClose' )
    ok = VRSetIni( "RexxAutoStart", "BackColor",  VRGet("RexxAutoStartMain","BackColor"),  our_ini, 'NoClose' )
    ok = VRSetIni( "RexxAutoStart", "Sound",  Sound,  our_ini )
return


/*:VRX         _LoadOtherFuncs
*/
_LoadOtherFuncs: 
    ok = VRRedirectStdIO('OFF')
    Call Rxfuncadd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
    Call SysLoadFuncs
    Call Rxfuncadd 'WPToolsLoadFuncs', 'WPTOOLS', 'WPToolsLoadFuncs'
    Call WPToolsLoadFuncs
    wptver = WPToolsVersion()
return

/*:VRX         _MsgOK
*/
_MsgOK: 
    Buttons.1 = "OK"
    Buttons.0 = 1
    if Msg.Title = 'MSG.TITLE' then Msg.Title = 'BinSuk/PM ('Group') message'
    id = VRMessage( VRWindow(), Msg.Text, Msg.Title, Msg.Type, "Buttons.", buttons.1, buttons.1 )
return

/*:VRX         _objTitle
*/
_objTitle: Procedure Expose autostrt verbose log_out log_file
    /* translate out carriage control characters */
    say 'ObjTitle entered'
    parse Arg title
    nlcrlf = D2c(94) || D2c(13) || D2c(10)
    title = Space(Translate(title, , nlcrlf))
    say 'ObjTitle done'
Return title
/*:VRX         _odwait
*/
_odwait: 
    say '_odwait entered'
    Call _sayout 'Waiting for Object Desktop to start.', 1
    success = 0
    If od_cc Then Do
        Call _sayout 'Waiting for [Control Center].', 2
        Parse Value(_waitod('Control Center', sleepsec, od_tries)) With success tries .
        If success Then open_msg = '[Control Center] has opened after' tries 'check(s).'
                   Else open_msg = '[Control Center] has not opened after' tries 'check(s).'
        Call _sayout open_msg, 3
    End
    Else Call _sayout '[Control Center] has not been selected for activation.', 2
    If od_tlp Then Do
        Call _sayout 'Waiting for [Tab LaunchPad].', 2
        Parse Value(_waitod('Tab LaunchPad', sleepsec, od_tries)) With success tries .
        If success Then open_msg = '[Tab LaunchPad] has opened after' tries 'check(s).'
                   Else open_msg = '[Tab LaunchPad] has not opened after' tries 'check(s).'
        Call _sayout open_msg, 3
    End
    Else Call _sayout '[Tab LaunchPad] has not been selected for activation.', 2
    If success Then open_msg = 'Object Desktop is started. Continuing...'
               Else open_msg = 'Object Desktop has not started. Continuing...'
    Call _sayout open_msg, 2
    say '_odwait done'
return 0

/*:VRX         _PlaySoundEvent
*/
_PlaySoundEvent: 
    parse arg SoundEventCode
    say '_PlaySoundEvent entered'
    say Sound
    say SoundEventCode
    if Sound then do
        SoundFile = _GetEventSound(SoundEventCode)
        if SoundFile \= '' then do
            threadID = VRMethod( "Application", "StartThread", "PlaySnd", SoundFile ) 
            say ThreadID
        end
        drop SoundEventCode SoundFile
    end
    else say 'No Sound!'
    say '_PlaySoundEvent done'
return
/*:VRX         _sayout
*/
_sayout: Procedure Expose verbose log_out log_file
/* console and log file output procedure */
save_trace = Trace('N')
Parse Arg msg, level
If \Datatype(level, 'W') Then
   level = 0
msg = Copies(' ', level) || msg
If verbose Then
   ok = VRSet("RexxAutostartMain" ,"StatusText", strip(msg))
If log_out Then
   Call Lineout log_file, Date() Time() msg
Trace (save_trace)
Return
/*:VRX         _SleepAnimated
*/
_SleepAnimated:
    if SleepSec <= 2 then do
        call SysSleep Sleepsec
        return
    end
    do JJ = 1 to SleepSec
       if JJ = 2 then ok = VRSet("RexxAutoStartMain","WindowIcon","$3")
       Call SysSleep 1
       if JJ = SleepSec-1 then ok = VRSet("RexxAutoStartMain","WindowIcon","$4")
   end
   ok = VRSet("RexxAutoStartMain","WindowIcon","$1")
return

/*:VRX         _WaitOD
*/
_waitod: Procedure Expose verbose log_out log_file sub_trace Sound
    /* wait for Object Desktop to start */
    say '_WaitOD entered'
    save_trace = Trace(sub_trace)
    Parse Arg title, sleep, od_tries
    rc_task = 0
    attempts = 0
    If \Rxfuncquery('SysQuerySwitchList') Then
    Do i = 1 To od_tries Until rc_task
        attempts = attempts + 1
        Call SysSleep sleep
        Call SysQuerySwitchList 'tasks.', 'IGN'
        Do j = 1 To tasks.0 Until rc_task
            rc_task = (Pos(title, tasks.j) <> 0)
        End
        call CheckForEvent
    End
    Else Call _sayout 'SysQuerySwitchList not available, returning...', 2
    Trace (save_trace)
    say '_WaitOD done'
return rc_task attempts

/*:VRX         _wpswait
*/
_wpswait: 
    say '_WPSWait entered'
    Call _sayout 'Waiting until the Desktop has been populated.', 1
    call CheckForEvent
    If warp4 Then Do /* Warp 4 or WSeB */
        If (SysWaitForShell("DESKTOPPOPULATED", "QUERY") = 0) Then Do
            Call SysWaitForShell "DESKTOPPOPULATED"
        End
    End
    Else Do /* Warp 3, taken from RXTT28.INF by Bernd Schemmer */
        xrc = SysIni('USER', 'PM_InstallObject', 'ALL:', 'stem')
        Do While xrc \= 'ERROR:'
            do x = 1 to sleepsec
                call CheckForEvent
                Call SysSleep 1
            end
            xrc = SysIni('USER', 'PM_InstallObject', 'ALL:', 'stem')           
        End
    End
    Call _sayout 'Desktop has been populated. Continuing...', 2
    say '_WPSWait done'
return 0

/*:VRX         CB_Sound_Click
*/
CB_Sound_Click: 
    Sound = VRGet("CB_Sound","set")
return

/*:VRX         CheckForEvent
*/
CheckForEvent: 
    /* check event queue */
    EventString = ''
    do until EventString = 'nop'
        EventString = VREvent('N')
        if EventString <> 'nop' then do
            interpret EventString
        end
    end
return
/*:VRX         Fini
*/
Fini:
    window = VRWindow()
    call VRSet window, "Visible", 0
    drop window
return 0

/*:VRX         Halt
*/
Halt:
    signal _VREHalt
return

/*:VRX         Init
*/
Init:
    window = VRWindow()
/*  call VRMethod window, "CenterWindow"
    call VRSet window, "Visible", 1  */
    call VRMethod window, "Activate"
    drop window
return

/*:VRX         PB_QuitNow_Click
*/
PB_QuitNow_Click: 
    say 'PB_QuitNow_Click entered/done'
    call _PlaySoundEvent('682')
    call SysSleep 1
    call Quit
return

/*:VRX         Quit
*/
Quit:
    call _cleanup
    window = VRWindow()
    call VRSet window, "Shutdown", 1
    drop window
    exit
return

/*:VRX         RexxAutoStartMain_Close
*/
RexxAutoStartMain_Close:
    call Quit
return

/*:VRX         RexxAutoStartMain_Create
*/
RexxAutoStartMain_Create: 
    Trace 'N'
    sub_trace = 'N'

    /* load other function libraries */
    call _LoadOtherFuncs

    /* Read Parameters von Environment variable or commandline */
    orgParms = VRGet("application","CommandLine") /* get commandline parameters */
    cmdparms = orgparms                           /* to enable check for help */
     
    If _initialize() Then do       /* initialize parameters and variables */
        say 'ver                   ='ver                  
        say 'verdate               ='verdate              
        say 'op_lvl                ='op_lvl           
        say 'warp4                 ='warp4                
        say 'ecs                   ='ecs                  
        say 'wseb                  ='wseb                 
        say 'verbose               ='verbose              
        say 'log_out               ='log_out              
        say 'testing               ='testing              
        say 'wps_wait              ='wps_wait             
        say 'delay_wait_default    ='delay_wait_default   
        say 'od_tries_default      ='od_tries_default     
        say 'sleepsec_default      ='sleepsec_default     
        say 'startupfolder_default ='startupfolder_default
        say 'retries_default       ='retries_default      
        say 'delay_wait            ='delay_wait           
        say 'odtest                ='odtest               
        say 'od_wait               ='od_wait              
        say 'od_cc                 ='od_cc                
        say 'od_tlp                ='od_tlp               
        say 'sleepsec              ='sleepsec             
        say 'startupfolder         ='startupfolder        
        say 'retries               ='retries              
        say 'do_help               ='do_help              
        say 'autoexec              ='autoexec             
        say 'sound                 ='sound
        say 'our_ini               ='our_ini
        say 'orgparms              ='orgparms
        xrc = 0
        Select
            When do_help Then Do                         /* give help */
                xrc = _helpscreen()
                xrc = _cleanup(xrc)
                call Quit
            End
            When autoexec Then Do                  /* execute program */
                Call _sayout prgfile 'started.', 0
                Call _sayout "Using parameters" parms || ".", 2
                If wps_wait Then        /* wait for Desktop population */
                    xrc = _wpswait()
                If od_wait Then             /* wait for Object Desktop */
                    xrc = _odwait()
                If delay_wait <> 0 Then    /* delay further processing */
                    xrc = _delayswitch()
                xrc = _autoexec()        /* open startupfolder objects */
                xrc = _cleanup(xrc)
            End
            Otherwise  nop
        End /* select */
    End /* if init... */
    call _PlaySoundEvent("681")
    call SysSleep 2
    call Quit
return
